package crosswordsage;

import javax.swing.*;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.BorderLayout;
import java.awt.*;

/**
 * <p>Title: Crossword Sage</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Ben Westgarth
 * @version 0.1
 */
public class MainScreen extends JFrame
{
    //define menu variables
    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu mTools = new JMenu();
    JMenuItem mTools_Solve = new JMenuItem();
    JPanel mainPanel = new JPanel();

    BorderLayout borderLayout1 = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();
    JMenu mHelp = new JMenu();
    JMenuItem mHelp_About = new JMenuItem();
    JMenuItem mHelp_Instructions = new JMenuItem();

    public MainScreen()
    {
        try
        {
            jbInit();
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    public static void main(String[] args)
    {
        MainScreen mainscreen = new MainScreen();
    }

    private void jbInit()
            throws Exception
    {
        this.show();
        this.getContentPane().setBackground(SystemColor.control);
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        this.setJMenuBar(jMenuBar1);
        this.setTitle("Crossword Sage");
        this.getContentPane().setLayout(borderLayout1);
        this.setBounds(0, 0, 700, 400);

        BuildMenu();

        jMenuBar1.setBackground(new Color(199, 223, 236));
        jMenuBar1.setBorder(BorderFactory.createLineBorder(Color.black));
        mTools.setBackground(new Color(199, 223, 236));
        mTools_Solve.setBackground(new Color(199, 223, 236));
        mHelp.setBackground(new Color(199, 223, 236));
        mHelp.setText("Help");
        mHelp_About.setText("About");
        mHelp_About.setBackground(new Color(199, 223, 236));
        mHelp_About.setActionCommand("About");
        mHelp_Instructions.setBackground(new Color(199, 223, 236));
        mHelp_Instructions.setText("Instructions");

        this.getContentPane().add(mainPanel, java.awt.BorderLayout.CENTER);
        mainPanel.setBackground(new Color(174, 190, 212));
        mainPanel.setLayout(borderLayout2);

        jMenuBar1.add(mTools);
        jMenuBar1.add(mHelp);

        mainPanel.add(new CrosswordSolverPanel());
        mHelp.add(mHelp_About);
        mHelp.add(mHelp_Instructions);
        validate();
    }

    private void BuildMenu()
    {
        mTools.setText("Tools");
        mTools_Solve.setText("Solve New Word");
        jMenuBar1.add(mTools);
        mTools.add(mTools_Solve);
        mTools.setActionCommand("Solve");

        //add listeners
        mTools_Solve.addActionListener(new MenuListener());
        mHelp_About.addActionListener(new MenuListener());
        mHelp_Instructions.addActionListener(new MenuListener());

    }

    private void showVersion()
    {
        JOptionPane.showMessageDialog(this, "Crossword Sage Version 0.2");
    }

    private void showInstructions()
    {
        JOptionPane.showMessageDialog(this,
                "Search the word list for a word pattern, anagram or combination of both. \n" +
            "To specify a pattern simply put a '*' in place of any letters you don't know. \n" +
            "eg. you know the 2nd and 6th letter of a 7 letter word --> *e***f*");
    }


    class MenuListener implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
            if (e.getActionCommand() == "Solve")
            {
                mainPanel.add(new CrosswordSolverPanel());
            }
            else if (e.getActionCommand() == "About")
            {
                showVersion();
            }
            else if (e.getActionCommand() == "Instructions")
            {
                showInstructions();
            }
            validate();
        }
    }
}
