package crosswordsage;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.print.*;

import javax.swing.*;
import java.awt.print.*;

public class MainScreen extends JFrame
{
    //define menu variables
    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu mTools = new JMenu();
    JMenuItem mTools_Solve = new JMenuItem();
    JPanel mainPanel = new JPanel();

    BorderLayout borderLayout1 = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();
    JMenu mHelp = new JMenu();
    JMenuItem mHelp_About = new JMenuItem();
    JMenuItem mHelp_Instructions = new JMenuItem();
    JMenuItem mTools_Builder = new JMenuItem();
    JMenu mFile = new JMenu();
    JMenuItem mFile_Save = new JMenuItem();
    JMenuItem mFile_Load = new JMenuItem();

    private CrosswordCompiler cc;
    JMenuItem mFile_Print = new JMenuItem();

    public MainScreen()
    {
        try
        {
            jbInit();
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    public static void main(String[] args)
    {
        MainScreen mainscreen = new MainScreen();
    }

    private void jbInit()
            throws Exception
    {
        this.show();
        this.getContentPane().setBackground(SystemColor.control);
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        this.setJMenuBar(jMenuBar1);
        this.setTitle("Crossword Sage");
        this.getContentPane().setLayout(borderLayout1);
        this.setBounds(0, 0, 700, 700);

        BuildMenu();

        jMenuBar1.setBackground(new Color(199, 223, 236));
        jMenuBar1.setBorder(BorderFactory.createLineBorder(Color.black));
        mTools.setBackground(new Color(199, 223, 236));
        mTools_Solve.setBackground(new Color(199, 223, 236));
        mHelp.setBackground(new Color(199, 223, 236));
        mHelp.setText("Help");
        mHelp_About.setText("About");
        mHelp_About.setBackground(new Color(199, 223, 236));
        mHelp_About.setActionCommand("About");
        mHelp_Instructions.setBackground(new Color(199, 223, 236));
        mHelp_Instructions.setText("Instructions");
        mTools_Builder.setBackground(new Color(199, 223, 236));
        mTools_Builder.setText("Crossword Builder");
        mFile.setBackground(new Color(199, 223, 236));
        mFile.setText("File");
        mFile_Save.setBackground(new Color(199, 223, 236));
        mFile_Save.setEnabled(false);
        mFile_Save.setText("Save Crossword");
        mFile_Load.setBackground(new Color(199, 223, 236));
        mFile_Load.setText("Load Crossword");
        mFile_Print.setBackground(new Color(199, 223, 236));
        mFile_Print.setText("Print Crossword");

        this.getContentPane().add(mainPanel, java.awt.BorderLayout.CENTER);
        mainPanel.setBackground(new Color(174, 190, 212));
        mainPanel.setLayout(borderLayout2);
        jMenuBar1.add(mFile);

        jMenuBar1.add(mTools);
        jMenuBar1.add(mHelp);

        mainPanel.add(new CrosswordSolverPanel());
        mHelp.add(mHelp_About);
        mHelp.add(mHelp_Instructions);
        validate();
        mTools.add(mTools_Builder);
        mFile.add(mFile_Save);
        mFile.add(mFile_Load);
        mFile.add(mFile_Print);
    }

    private void BuildMenu()
    {
        mTools.setText("Tools");
        mTools_Solve.setText("Solve New Word");
        jMenuBar1.add(mTools);
        mTools.add(mTools_Solve);
        mTools.setActionCommand("Solve");

        //add listeners
        mTools_Solve.addActionListener(new MenuListener());
        mHelp_About.addActionListener(new MenuListener());
        mHelp_Instructions.addActionListener(new MenuListener());
        mTools_Builder.addActionListener(new MenuListener());
        mFile_Save.addActionListener(new MenuListener());
        mFile_Load.addActionListener(new MenuListener());
        mFile_Print.addActionListener(new MenuListener());
    }

    private void showCrosswordBuilder()
    {
        mainPanel.removeAll();
        cc = new CrosswordCompiler();
        mFile_Save.setEnabled(true);
        mainPanel.add(cc);
        validate();
    }

    private void saveCrossword()
    {
        cc.saveCrossword(this);
    }

    private void loadCrossword()
    {
        mainPanel.removeAll();
        cc = new CrosswordCompiler();
        mainPanel.add(cc);
        mFile_Save.setEnabled(true);
        cc.loadCrossword(this);
    }

    private void printCrossword()
    {
        cc.print();

/*        PrinterJob pj = PrinterJob.getPrinterJob();
        //PrintService ps = pj.getPrintService();
        pj.setPrintable(new CrosswordPage());

        if(pj.printDialog())
        {
            try
            {
                pj.print();
            }
            catch (PrinterException ex)
            {
            }
        }
*/
    }


    private void showVersion()
    {
        JOptionPane.showMessageDialog(this, "Crossword Sage Version 0.2.2. \n For further information, downloads and \n" +
                "the latest version of Crossword Sage, \n visit http://crosswordsage.sourceforge.net");
    }

    private void showInstructions()
    {
        JOptionPane.showMessageDialog(this,
                "Search the word list for a word pattern, anagram or combination of both. \n" +
            "To specify a pattern simply put a '*' in place of any letters you don't know. \n" +
            "eg. you know the 2nd and 6th letter of a 7 letter word --> *e***f*");
    }


    class MenuListener implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
            if (e.getActionCommand() == "Solve New Word")
            {
                mainPanel.removeAll();
                mainPanel.add(new CrosswordSolverPanel());
            }
            else if(e.getActionCommand() == "Crossword Builder")
            {
                showCrosswordBuilder();
            }
            else if (e.getActionCommand() == "About")
            {
                showVersion();
            }
            else if (e.getActionCommand() == "Instructions")
            {
                showInstructions();
            }
            else if(e.getSource().equals(mFile_Load))
            {
                loadCrossword();
            }
            else if(e.getSource().equals(mFile_Save))
            {
                saveCrossword();
            }
            else if(e.getSource().equals(mFile_Print))
            {
                printCrossword();
            }

            validate();
        }


    }
}
